using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;

using Bots.DungeonBuddy.Attributes;
using Bots.DungeonBuddy.Helpers;

using Styx;
using Styx.Logic;
using Styx.Logic.Combat;
using Styx.Combat.CombatRoutine;
using Styx.Logic.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using TreeSharp;
using Action = TreeSharp.Action;


namespace Bots.DungeonBuddy.Dungeon_Scripts.Cataclysm
{
    public class TheSiegeOfWyrmrestTempleHeroic : Dungeon
    {
        #region Overrides of Dungeon
        public override uint DungeonId
        {
            get { return 416; }
        }
        public override WoWPoint Entrance { get { return new WoWPoint(-8263.148f, -4510.692f, -219.3243f); } }

        /// <summary>
        ///   IncludeTargetsFilter is used to add units to the targeting list. If you want to include a mob thats usually removed by the default filters, you shall use that.
        /// </summary>
        /// <param name="incomingunits"> Units passed into the method </param>
        /// <param name="outgoingunits"> Units passed to the targeting class </param>
        public override void IncludeTargetsFilter(List<WoWObject> incomingunits, HashSet<WoWObject> outgoingunits)
        {
            foreach (var obj in incomingunits)
            {
                var unit = obj as WoWUnit;
                if (unit != null)
                {

                }
            }
        }

        /// <summary>RemoveTargetsFilter is used to remove units thats not wanted in target list. Like immune mobs etc.</summary>
        /// <param name="units">The incomingunits.</param>
        public override void RemoveTargetsFilter(List<WoWObject> units)
        {
            foreach (var obj in units)
            {
                var unit = obj as WoWUnit;
                if (unit != null)
                {

                }
            }
        }
        public override void WeighTargetsFilter(List<Targeting.TargetPriority> units)
        {
            foreach (var priority in units)
            {
                var unit = priority.Object as WoWUnit;
                if (unit != null)
                {
                    //Madness, Ship, Hagara
                    //Blistering Tentacles, Twilight Sapper, Frozen Binding Crystal,Bound Lightning Elemental
                    /*if (unit.Entry.Equals(new uint[] { 56188, 56923, 56136, 56700 }))
                    {
                        priority.Score += 400;
                    }*/
                    //Yor'Sahj
                    //add the bubbles in the needed priority

                    //Zonozz Hardmode

                    //Spine of Deathwing
                    //Hideous Amalgamation, Corrupted Blood, Corruption with Fiery Grip, Burning Tendron
                }
            }
        }
        #endregion

        #region Encounter Handlers
        private uint crystalEntry = 55346;
        //[EncounterHandler(0)]
        /*
         * public Composite RootLogic()
         * {
         * }
         */
        private static uint resonatingCrystals = 55346;
        private static uint InnerWall = 209596;
        private static List<WoWGameObject> MorchockPillars {get{return ObjectManager.GetObjectsOfType<WoWGameObject>().Where(w => w.Entry == InnerWall).OrderBy(w=>w.Distance).ToList();}}
        private static WoWGameObject MorchockCrystals { get { return ObjectManager.GetObjectsOfType<WoWGameObject>().Where(q => q.Entry == resonatingCrystals).FirstOrDefault(); } }
        [EncounterHandler(55265, "Morchock", Mode = CallBehaviorMode.Proximity, BossRange = 200)]
        public Composite MorchockEncounter()
        {
            var tankBossLoc = new WoWPoint(-1970.588, -2408.602, 68.5843);

            var bossFarPathEndLoc = new WoWPoint(-2005.624, -2409.554, 70.20834);
            //<Hotspot X="-2005.624" Y="-2409.554" Z="70.20834" />
            var trashTankLoc = new WoWPoint(-2054.229, -2406.151, 73.31179);
            /* Trash packs for Hardmode to be cleared
             * <Hotspot X="-2033.066" Y="-2356.053" Z="70.50761" />
             * <Hotspot X="-1977.595" Y="-2305.988" Z="65.32207" />
             * <Hotspot X="-1977.17" Y="-2494.873" Z="64.29511" />
             * <Hotspot X="-2043.77" Y="-2517.459" Z="71.97334" />
             */
            var partyWaitLoc = new WoWPoint(-2054.229, -2406.151, 73.31179);

            WoWUnit boss = null, trash = null;
            return new PrioritySelector(
                ctx => boss = ctx as WoWUnit,
                // Clear the area and then pull boss.
                new Decorator(
                    ctx => !boss.Combat,
                    new PrioritySelector(
                        ctx => trash = ScriptHelpers.GetUnfriendlyNpsAtLocation(() => tankBossLoc, 50, u => u != boss).FirstOrDefault(),
                // pull the trash when boss is far away
                        ScriptHelpers.CreatePullNpcToLocation(
                            ctx => trash != null && !StyxWoW.Me.Combat,
                            ctx => boss.Location.DistanceSqr(bossFarPathEndLoc) <= 25 * 25 || trash.Location.DistanceSqr(trashTankLoc) <= 50 * 50,
                            () => trash, () => trashTankLoc, () => StyxWoW.Me.IsTank() ? trashTankLoc : partyWaitLoc, 5),
                // pull boss when he's near and trash is cleared.
                        ScriptHelpers.CreatePullNpcToLocation(
                            ctx => trash == null && StyxWoW.Me.Location.DistanceSqr(tankBossLoc) <= 50 * 50,
                            ctx => boss.Location.DistanceSqr(tankBossLoc) <= 25 * 25,
                            () => boss, () => tankBossLoc, () => StyxWoW.Me.IsTank() ? tankBossLoc : StyxWoW.Me.Location, 5)
                        )),
                // Handle boss encounter
                new Decorator(
                    ctx => boss.Combat,
                    new PrioritySelector(                       
                        
                        new Decorator(
                            ret => (StyxWoW.Me.HasAura(103534) || StyxWoW.Me.HasAura(103541) || StyxWoW.Me.HasAura(103536)) && !StyxWoW.Me.IsTank(),
                            ScriptHelpers.CreateWaitAtLocationWhile(ret => (StyxWoW.Me.HasAura(103534) || StyxWoW.Me.HasAura(103541) || StyxWoW.Me.HasAura(103536)) && !StyxWoW.Me.IsTank(), () => MorchockCrystals.Location, 10)
                            ),
                        ScriptHelpers.CreateLosLocation(ctx => MorchockPillars.Count>=1,()=>boss.Location,()=>MorchockPillars[0].Location, ()=>10), //Run to the Pillars
                        ScriptHelpers.CreateRunAwayFromBad(ctx => true, 30, 103851, 103785), //If behin Pillars, runaway from Blood
                        //103687 - Crush Armor
                        new Decorator(ret => StyxWoW.Me.IsTank() && boss.CurrentTarget.Guid != StyxWoW.Me.Guid && GetStacksOfDebuff(boss.CurrentTarget, "Crush Armor") > 3, CreateTankTaunt(boss))
                        )
                    )
                    );
        }
        private uint GetStacksOfDebuff(WoWUnit unit, string Debuff)
        {
            if (unit != null && unit.HasAura(Debuff))
                return unit.Auras[Debuff].StackCount;
            return 0;
        }
        private Composite CreateTankTaunt(WoWUnit tar)
        {
            string tauntSpell1 = null;
            string tauntSpell2 = null;
            switch (StyxWoW.Me.Class)
            {
                case WoWClass.DeathKnight:
                    tauntSpell1 = "Dark Command";
                    tauntSpell2 = "Death Grip";
                    break;
                case WoWClass.Druid:
                    tauntSpell1 = "Growl";
                    tauntSpell2 = "Challenging Roar";
                    break;
                case WoWClass.Paladin:
                    tauntSpell1 = "Hand of Reckoning";
                    tauntSpell2 = "Righteous Defense";
                    break;
                case WoWClass.Warrior:
                    tauntSpell1 = "Taunt";
                    tauntSpell2 = "Intervene";
                    break;
            }
            return new Decorator(ret => StyxWoW.Me.IsTank() && tar.CurrentTarget.Guid != StyxWoW.Me.Guid,
                new PrioritySelector(
                    new Decorator(
                        ret => SpellManager.CanCast(tauntSpell1),
                        new Action(ret => SpellManager.Cast(tauntSpell1, tar))),
                        new Decorator(
                        ret => SpellManager.CanCast(tauntSpell2),
                        new Action(ret => SpellManager.Cast(tauntSpell2, tar)))));
        }
        #endregion
    }
}
